---
title: Firefox 54 for developers
slug: Mozilla/Firefox/Releases/54
tags:
  - '54'
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div>

<p class="summary">Firefox 54 was released on June 13, 2017. This article lists key changes that are useful for web developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<div id="my-test">
<ul>
 <li>The network request summary now includes the amount of data actually transferred ("transferred size"), as does the performance analysis view ({{bug(1168376)}}).</li>
 <li>The network request headers view now links to the related documentation on MDN ({{bug(1320233)}}).</li>
</ul>
</div>

<h3 id="CSS">CSS</h3>

<ul>
 <li>{{cssxref("clip-path")}} now supports <a href="/en-US/docs/Web/CSS/CSS_Shapes">basic shapes</a> ({{bug(1247229)}}).</li>
 <li>Firefox's implementations of CSS Flexbox and CSS alignment now implement updated spec language for interactions between the properties {{cssxref("align-items")}} and {{cssxref("align-self")}}  as well as between {{cssxref("justify-items")}} and {{cssxref("justify-self")}} ({{bug(1340309)}}).</li>
 <li>{{htmlelement("input")}} elements of types <code>checkbox</code> and <code>radio</code> with {{cssxref("appearance", "-moz-appearance")}}<code>: none;</code> set on them are now non-replaced elements, for compatibility with other browsers ({{bug(605985)}}).</li>
 <li>Previously, an element styled with {{cssxref("display")}}:<code> inline-block</code> with a child element of type {{domxref("HTMLInputElement")}} styled with <code>display:block</code> had a wrong baseline ({{bug(1330962)}}). This is now fixed.</li>
 <li>When Mozilla introduced dedicated content threads to Firefox (through the Electrolysis or e10s project), support for styling {{HTMLElement("option")}} elements was removed temporarily. Starting in Firefox 54, you can apply foreground and background colors to <code>&lt;option&gt;</code> elements again, using the {{cssxref("color")}} and {{cssxref("background-color")}} attributes. See {{bug(910022)}} for more information. Note that this is still disabled in Linux due to lack of contrast (see {{bug(1338283)}} for progress on this).</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Animations">CSS Animations</a> now send the {{event("animationcancel")}} event as expected when an animation aborts prematurely ({{bug(1302648)}}).</li>
 <li>Transparent colors (i.e. those with an alpha channel of 0) were being serialized to the <a href="/en-US/docs/Web/CSS/color_value#transparent_keyword"><code>transparent</code> color keyword</a> in <a href="https://www.fxsitecompat.com/en-CA/docs/2017/transparent-rgba-colour-values-are-no-longer-serialized-to-transparent-keyword/">certain situations</a>; this has been fixed so that Firefox follows the spec (as well as other browsers' implementations). See ({{bug("1339394")}} for further information.</li>
 <li>The proprietary <code>:-moz-table-border-nonzero</code> pseudo-class is no longer available to web content; it is now restricted to Firefox's internal UA sylesheet ({{bug(1341925)}}).</li>
 <li>[css-grid] Intristic content with overflow:auto overlaps in grid ({{bug(1348857)}}).</li>
 <li>[css-grid] Transferred min-size contribution of percentage size grid item with an intrinsic ratio ({{bug(1349320)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><code>\b</code> and <code>\B</code> in {{jsxref("RegExp")}} with the <code>"u"</code> (Unicode) and <code>"i"</code> (case insensitive) flags now treat U+017F (LATIN SMALL LETTER LONG S) and U+212A (KELVIN SIGN) as word characters ({{bug(1338373)}}).</li>
 <li>The {{jsxref("DataView")}} constructor now throws a {{jsxref("RangeError")}} if the <code>byteOffset</code> parameter is out of {{jsxref("Number.MAX_SAFE_INTEGER")}} (&gt;= 2 ** 53) ({{bug(1317382)}}).</li>
 <li>The {{jsxref("Date.UTC()")}} method has been updated to conform to ECMAScript 2017 when fewer than two arguments are provided ({{bug(1050755)}}).</li>
 <li>The {{jsxref("Function.prototype.toString()")}} method has been updated to match the latest <a href="https://tc39.github.io/Function-prototype-toString-revision/">proposed specification</a> ({{bug(1317400)}}).</li>
</ul>

<h3 id="DOM_HTML_DOM">DOM &amp; HTML DOM</h3>

<ul>
 <li>The {{domxref("URL.toJSON()")}} method has been implemented ({{bug(1337702)}}).</li>
 <li>The {{domxref("URLSearchParams.URLSearchParams", "URLSearchParams()")}} constructor now accepts a record containing {{domxref("USVString")}}s as an init object ({{bug("1331580")}}).</li>
 <li>Values returned in {{domxref("KeyboardEvent.key")}} for printable keys when the control key is also pressed have been corrected on macOS (except when the Command key is pressed) ({{bug(1342865)}}).</li>
 <li>The <code>dom.workers.latestJSVersion</code> preference, which was mainly implemented to work around problems using <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code> in workers (due to {{bug(855665)}}, which has since been fixed) has been removed (see {{bug(1219523)}}).</li>
 <li>The {{domxref("event.timeStamp")}} property now returns a high-resolution monotonic time ({{domxref("DOMHighResTimeStamp")}}) instead of an epoch time ({{domxref("DOMTimeStamp")}}).</li>
</ul>

<h3 id="Web_Workers_and_Service_Workers">Web Workers and Service Workers</h3>

<ul>
 <li>{{domxref("WorkerGlobalScope.close")}} is now available on {{domxref("DedicatedWorkerGlobalScope.close", "DedicatedWorkerGlobalScope")}} and {{domxref("SharedWorkerGlobalScope.close", "SharedWorkerGlobalScope")}} instead. This change was made to stop <code>close()</code> being available on service workers, as it isn't supposed to be used there and always throws an exception when called (see {{bug(1336043)}}).</li>
 <li>The {{domxref("WindowOrWorkerGlobalScope.origin")}} property has been implemented (see {{bug(1306170)}}).</li>
 <li>The {{domxref("Client.type")}} property has been implemented (see {{bug(1339844)}}).</li>
 <li>{{domxref("Clients.matchAll()")}} now returns {{domxref("Client")}} objects in most recently focused order (see {{bug(1266747)}}).</li>
 <li>Some changes have been made to the observed behaviour when the {{domxref("Request.Request","Request()")}} constructor is passed an existing {{domxref("Request")}} object instance to make a new instance. The following new behaviors are designed to retain security while making the constructor less likely to throw exceptions:
  <ul>
   <li>If this object exists on another origin to the constructor call, the {{domxref("Request.referrer")}} is stripped out.</li>
   <li>If this object has a {{domxref("Request.mode")}} of <code>navigate</code>, the <code>mode</code> value is converted to <code>same-origin</code>.</li>
  </ul>
 </li>
</ul>

<h3 id="AudioVideo">Audio/Video</h3>

<h4 id="General">General</h4>

<ul>
 <li>5.1 surround sound playback is now enabled by default on Windows, macOS, and Linux ({{bug(1334508)}}, {{bug(1321502)}} , and {{bug(1323659)}}).</li>
</ul>

<h4 id="Media_Capture_and_Streams_API">Media Capture and Streams API</h4>

<ul>
 <li>Usage of a {{domxref("MediaStream")}} object as the input parameter to {{domxref("URL.createObjectURL()")}} has been deprecated — the console will now show a warning (see {{bug(1334564)}}). You are advised to use {{domxref("HTMLMediaElement.srcObject")}} instead.</li>
</ul>

<h4 id="Web_Audio_API">Web Audio API</h4>

<ul>
 <li>The method {{domxref("AnalyserNode.getFloatFrequencyData()")}} now correctly represents silent samples in the returned buffer with the value <code>-<a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Infinity">Infinity</a></code> ({{bug(1336098)}}).</li>
 <li>{{domxref("AudioParam.setValueCurveAtTime()")}} now throws a <code>TypeError</code> exception if any of the specified values aren't finite ({{bug(1308437)}}).</li>
</ul>

<h4 id="Encrypted_MediaExtensions_API">Encrypted MediaExtensions API</h4>

<ul>
 <li>The <code>MediaKeySession.keySystem</code> string has been removed from the specification, and as such we've taken it out of Firefox 54 ({{bug(1335555)}}).</li>
 <li>Support has been added for the VP9 codec in encrypted streams using <a href="https://www.w3.org/TR/encrypted-media/#clear-key">Clear Key</a> and <a href="http://www.widevine.com/">Widevine</a> ({{bug(1338064)}}).</li>
 <li>Previously, MSE was only allowed to use WebM/VP8 video if the system was considered "fast enough." Now playback of VP8-encoded <code>webm/video</code> media is always supported, regardless of system performance.</li>
</ul>

<h4 id="WebRTC">WebRTC</h4>

<ul>
 <li>TCP ICE candidate support, originally added in Firefox 41, is now enabled by default. This allows the ICE layer to consider candidates that use TCP rather than the preferred UDP for transmission. This can be useful in environments in which UDP is blocked ({{bug(1176382)}}). This <a href="https://blog.mozilla.org/webrtc/active-ice-tcp-punch-firewalls-directly/">blog post</a> explains the feature in more details.</li>
</ul>


<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="CSS_2">CSS</h3>

<ul>
 <li>Removed the <code>-moz</code> prefixed versions of <code>isolate</code>, <code>isolate-override</code>, and <code>plaintext</code> values for the {{cssxref("unicode-bidi")}} property ({{bug(1333675)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>HTTP/1 Pipelining support has been removed in Firefox 54. Maintaining it as we make the move into a new world full of HTTP/2 and other substantial, standardized improvements to networking performance is not worthwhile given pipelining's compatibility and performance issues. The <code>network.http.pipelining</code> preference (as well as the other preferences that start with "network.http.pipelining") is now ignored. See {{bug(1340655)}} for further information.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/54">Site Compatibility for Firefox 54</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(53)}}</p>
